洛谷P3043「Usaco2012 Jan」奶牛联盟

这题tarjan缩点的思路不难想到,关键是怎么统计
我们思考每个部分的贡献是什么

对于一个环,我们只有两种方法,因为每条边必须和一个点分在一组
所以只有顺时针到底和逆时针到底两种方式

对于一个非环部分,我们有 s i z e size size中方法,实际上就是一个图多一条伸出去的边

那么我们如何判断呢,不难发现,,一个环,环内的边一定等于换的大小
我们统计一下每次判断就行了…

#include<iostream>
#include<cstdlib>
#include<cstdio>
#include<algorithm>
#include<cmath>
#include<cstring>
#include<queue>
using namespace std;
const int maxn = 200007;
const int mod = 1e9+7; 
const int INF = 2147483647;
struct node{
    int to,next,w;
}edge[maxn*2];
int cnt,head[maxn];
void add(int from,int to){
    edge[++cnt].to=to;
    edge[cnt].next=head[from];
    head[from]=cnt;
}
 
int co[maxn],dfn[maxn],low[maxn],st[maxn],instack[maxn],top,visn,tot;
long long num[maxn];
void tarjan(int u){
    st[++top]=u;
    dfn[u]=low[u]=++visn;
    instack[u]=1;
    for(int i=head[u];i;i=edge[i].next){
        int to=edge[i].to;
        if(!dfn[to]){
            tarjan(to);
            low[u]=min(low[u],low[to]);
        }
        else if(!co[to])low[u]=min(low[u],dfn[to]);
    }
    if(dfn[u]==low[u]){
        int t;tot++;
        do{
            t=st[top--];
            num[tot]++;
            co[t]=tot;
            instack[t]=0;
        }while(t!=u);
    }
}
long long del[maxn];
int F[maxn],T[maxn],n,m;
int main(){
    scanf("%d%d",&n,&m);
    for(int i=1;i<=m;i++){
        int x,y;
        scanf("%d%d",&x,&y);
        F[i]=x,T[i]=y;
        add(x,y),add(y,x);
    }
    for(int i=1;i<=n;i++){
        if(!dfn[i])tarjan(i);
    }
    
    for(int i=1;i<=n;i++)cout<<co[i]<<" "; 
    cout<<endl;
    for(int i=1;i<=m;i++){
        int c1=co[F[i]];
        int c2=co[T[i]];
        if(c1==c2)del[c1]++;
    }
    long long ans=1;
    for(int i=1;i<=tot;i++){
        if(del[i]==num[i])num[i]=2;
        ans=(ans%mod*num[i]%mod)%mod;
    }
    cout<<ans;
}
/*
6 6
1 2
2 3
3 4
4 5
5 6
6 4
*/
好的,这是一道经典的单调栈问题。题目描述如下: 有 $n$ 个湖,第 $i$ 个湖有一个高度 $h_i$。现在要在这些湖之间挖一些沟渠,使得相邻的湖之间的高度差不超过 $d$。请问最少需要挖多少个沟渠。 这是一道单调栈的典型应用题。我们可以从左到右遍历湖的高度,同时使用一个单调栈来维护之前所有湖的高度。具体来说,我们维护一个单调递增的栈,栈中存储的是湖的下标。假设当前遍历到第 $i$ 个湖,我们需要在之前的湖中找到一个高度最接近 $h_i$ 且高度不超过 $h_i-d$ 的湖,然后从这个湖到第 $i$ 个湖之间挖一条沟渠。具体的实现可以参考下面的代码: ```c++ #include <cstdio> #include <stack> using namespace std; const int N = 100010; int n, d; int h[N]; stack<int> stk; int main() { scanf("%d%d", &n, &d); for (int i = 1; i <= n; i++) scanf("%d", &h[i]); int ans = 0; for (int i = 1; i <= n; i++) { while (!stk.empty() && h[stk.top()] <= h[i] - d) stk.pop(); if (!stk.empty()) ans++; stk.push(i); } printf("%d\n", ans); return 0; } ``` 这里的关键在于,当我们遍历到第 $i$ 个湖时,所有比 $h_i-d$ 小的湖都可以被舍弃,因为它们不可能成为第 $i$ 个湖的前驱。因此,我们可以不断地从栈顶弹出比 $h_i-d$ 小的湖,直到栈顶的湖高度大于 $h_i-d$,然后将 $i$ 入栈。这样,栈中存储的就是当前 $h_i$ 左边所有高度不超过 $h_i-d$ 的湖,栈顶元素就是最靠近 $h_i$ 且高度不超过 $h_i-d$ 的湖。如果栈不为空,说明找到了一个前驱湖,答案加一。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值